class Api::Pm::PipelinesController < Api::Pm::BaseController
  include RepositoriesHelper

  def index
    @owner = Owner.find_by(login: params[:owner_id].to_s) || Owner.find_by(id: params[:owner_id].to_s)
    tip_exception('组织未找到') if @owner.blank?
    unless @owner.is_a?(Organization) && @owner.is_member?(current_user.id)
      tip_exception('没有查看组织的权限')
    end
    @project_ids = @owner.projects.ids
    project_gpids = @owner.projects.pluck(:gpid)
    action_runs = Gitea::ActionRun.where(owner_id: @owner.gitea_uid)
    group_data = action_runs.where(status: [1,2]).group(:workflow_id, :status).count
    pipelines = Action::Pipeline.where(project_id: @project_ids).order(updated_at: :desc)
    run_files = Gitea::ActionRun.select(:workflow_id, :repo_id).where(owner_id: @owner.gitea_uid).group(:workflow_id, :repo_id)
    db_files = pipelines.pluck(:file_name)
    @run_result = []
    run_files.each do |file_info|
      file = file_info.workflow_id
      project = Project.find_by(gpid: file_info.repo_id)
      next if project.blank?
      unless db_files.include?(".gitea/workflows/#{file}")
        pipeline = Action::Pipeline.find_or_initialize_by(pipeline_name: file.to_s.gsub(".yml", "").gsub(".yaml", ""),
                                        file_name: ".gitea/workflows/#{file}",
                                        branch: project.default_branch,
                                        is_graphic_design: false,
                                        disable: false,
                                        project_id: project.id)
        interactor = Repositories::EntriesInteractor.call(@owner, project.identifier, ".gitea/workflows/#{file}", ref: project.default_branch)
        if interactor.success?
          pipeline.yaml = decode64_content(interactor.result, @owner, project.repository, project.default_branch, nil)
        end
        pipeline.user_id  = current_user.id
        pipeline.save
        # 导入的流水线统一先禁用
        $gitea_hat_client.post_repos_actions_disable(project&.owner&.login, project&.identifier, {query: {workflow: file}}) rescue nil
      end
      last_action_run = action_runs.where(repo_id: project.gpid).where(workflow_id: file).order(updated: :desc).first
      last_action_run_json = last_action_run.present? ? {
        id: last_action_run.id,
        schedule: last_action_run.schedule_id > 0,
        title: last_action_run.title,
        index: last_action_run.index,
        status: last_action_run.status,
        started: last_action_run.started,
        stopped: last_action_run.stopped,
        length: last_action_run.stopped-last_action_run.started,
        created: last_action_run.created,
        updated: last_action_run.updated,
      } : {}

      total = 0
      success = 0
      failure = 0
      group_data.each do |k,v|
        total += v if k[0] == file
        success += v if k[0] == file && k[1] == 1
        failure += v if k[0] == file && k[1] == 2
      end
      @run_result << {
        repo_id: last_action_run.repo_id,
        filename: ".gitea/workflows/#{file}",
        total: total,
        success: success,
        failure: failure
      }.merge(last_action_run_json)
    end
    # Rails.logger.info("@run_result======#{@run_result}")
    @disabled_workflows = Gitea::RepoUnit.where(repo_id: project_gpids, type: 10).where("config is not null")
    @pipelines = Action::Pipeline.select("distinct project_id,max(updated_at) as updated_at")
                                 .where(project_id: @project_ids).group(:project_id).order("updated_at desc")
    @pipelines =  @pipelines.where("pipeline_name like ?", "%#{params[:pipeline_name]}%") if params[:pipeline_name].present?
    @pipelines =  @pipelines.where(pipeline_type: params[:pipeline_type]) if params[:pipeline_type].present?
    @pipelines = kaminari_paginate(@pipelines)
  end

end
